<?php
/**
 * Custom functions that act independently of the theme templates.
 *
 * Eventually, some of the functionality here could be replaced by core features.
 *
 * @package travel_planning
 */

/**
 * Adds custom classes to the array of body classes.
 *
 * @param array $classes Classes for the body element.
 * @return array
 */
function travel_planning_body_classes( $classes ) {
  global $travel_planning_post;
  
    if( !is_page_template( 'template-home.php' ) ){
        $classes[] = 'inner';
        // Adds a class of group-blog to blogs with more than 1 published author.
    }

    if ( is_multi_author() ) {
        $classes[] = 'group-blog ';
    }

    // Adds a class of custom-background-image to sites with a custom background image.
    if ( get_background_image() ) {
        $classes[] = 'custom-background-image';
    }
    
    // Adds a class of custom-background-color to sites with a custom background color.
    if ( get_background_color() != 'ffffff' ) {
        $classes[] = 'custom-background-color';
    }
    

    if( travel_planning_woocommerce_activated() && ( is_shop() || is_product_category() || is_product_tag() || 'product' === get_post_type() ) && ! is_active_sidebar( 'shop-sidebar' ) ){
        $classes[] = 'full-width';
    }    

    // Adds a class of hfeed to non-singular pages.
    if ( ! is_page() ) {
        $classes[] = 'hfeed ';
    }
  
    if( is_404() ||  is_search() ){
        $classes[] = 'full-width';
    }
  
    if( ! is_active_sidebar( 'right-sidebar' ) ) {
        $classes[] = 'full-width'; 
    }

    return $classes;
}
add_filter( 'body_class', 'travel_planning_body_classes' );

 /**
 * 
 * @link http://www.altafweb.com/2011/12/remove-specific-tag-from-php-string.html
 */
function travel_planning_strip_single( $tag, $string ){
    $string=preg_replace('/<'.$tag.'[^>]*>/i', '', $string);
    $string=preg_replace('/<\/'.$tag.'>/i', '', $string);
    return $string;
}

if ( ! function_exists( 'travel_planning_excerpt_more' ) ) :
/**
 * Replaces "[...]" (appended to automatically generated excerpts) with ... * 
 */
function travel_planning_excerpt_more($more) {
  return is_admin() ? $more : ' &hellip; ';
}
endif;
add_filter( 'excerpt_more', 'travel_planning_excerpt_more' );

if( ! function_exists( 'travel_planning_footer_credit' ) ):
/**
 * Footer Credits
*/
function travel_planning_footer_credit() {

    // Check if footer copyright is enabled
    $travel_planning_show_footer_copyright = get_theme_mod( 'travel_planning_footer_setting', true );

    if ( ! $travel_planning_show_footer_copyright ) {
        return; 
    }

    $travel_planning_copyright_text = get_theme_mod('travel_planning_footer_copyright_text');

    $travel_planning_text = '<div class="site-info"><div class="container"><span class="copyright">';
    if ($travel_planning_copyright_text) {
        $travel_planning_text .= wp_kses_post($travel_planning_copyright_text); 
    } else {
        $travel_planning_text .= esc_html__('&copy; ', 'travel-planning') . date_i18n(esc_html__('Y', 'travel-planning')); 
        $travel_planning_text .= ' <a href="' . esc_url(home_url('/')) . '">' . esc_html(get_bloginfo('name')) . '</a>' . esc_html__('. All Rights Reserved.', 'travel-planning');
    }
    $travel_planning_text .= '</span>';
    $travel_planning_text .= '<span class="by"> <a href="' . esc_url('https://www.themeignite.com/products/travel-planning') . '" rel="nofollow" target="_blank">' . TRAVEL_PLANNING_THEME_NAME . '</a>' . esc_html__(' By ', 'travel-planning') . '<a href="' . esc_url('https://themeignite.com/') . '" rel="nofollow" target="_blank">' . esc_html__('Themeignite', 'travel-planning') . '</a>.';
    /* translators: %s: link to WordPress.org */
    $travel_planning_text .= sprintf(esc_html__(' Powered By %s', 'travel-planning'), '<a href="' . esc_url(__('https://wordpress.org/', 'travel-planning')) . '" target="_blank">WordPress</a>.');
    if (function_exists('the_privacy_policy_link')) {
        $travel_planning_text .= get_the_privacy_policy_link();
    }
    $travel_planning_text .= '</span></div></div>';
    echo apply_filters('travel_planning_footer_text', $travel_planning_text);
}
add_action('travel_planning_footer', 'travel_planning_footer_credit');
endif;

/**
 * Is Woocommerce activated
*/
if ( ! function_exists( 'travel_planning_woocommerce_activated' ) ) {
  function travel_planning_woocommerce_activated() {
    if ( class_exists( 'woocommerce' ) ) { return true; } else { return false; }
  }
}

if( ! function_exists( 'travel_planning_change_comment_form_default_fields' ) ) :
/**
 * Change Comment form default fields i.e. author, email & url.
 * https://blog.josemcastaneda.com/2016/08/08/copy-paste-hurting-theme/
*/
function travel_planning_change_comment_form_default_fields( $fields ){    
    // get the current commenter if available
    $travel_planning_commenter = wp_get_current_commenter();
 
    // core functionality
    $req      = get_option( 'require_name_email' );
    $travel_planning_aria_req = ( $req ? " aria-required='true'" : '' );
    $travel_planning_required = ( $req ? " required" : '' );
    $travel_planning_author   = ( $req ? __( 'Name*', 'travel-planning' ) : __( 'Name', 'travel-planning' ) );
    $travel_planning_email    = ( $req ? __( 'Email*', 'travel-planning' ) : __( 'Email', 'travel-planning' ) );
 
    // Change just the author field
    $fields['author'] = '<p class="comment-form-author"><label class="screen-reader-text" for="author">' . esc_html__( 'Name', 'travel-planning' ) . '<span class="required">*</span></label><input id="author" name="author" placeholder="' . esc_attr( $travel_planning_author ) . '" type="text" value="' . esc_attr( $travel_planning_commenter['comment_author'] ) . '" size="30"' . $travel_planning_aria_req . $travel_planning_required . ' /></p>';
    
    $fields['email'] = '<p class="comment-form-email"><label class="screen-reader-text" for="email">' . esc_html__( 'Email', 'travel-planning' ) . '<span class="required">*</span></label><input id="email" name="email" placeholder="' . esc_attr( $travel_planning_email ) . '" type="text" value="' . esc_attr(  $travel_planning_commenter['comment_author_email'] ) . '" size="30"' . $travel_planning_aria_req . $travel_planning_required. ' /></p>';
    
    $fields['url'] = '<p class="comment-form-url"><label class="screen-reader-text" for="url">' . esc_html__( 'Website', 'travel-planning' ) . '</label><input id="url" name="url" placeholder="' . esc_attr__( 'Website', 'travel-planning' ) . '" type="text" value="' . esc_attr( $travel_planning_commenter['comment_author_url'] ) . '" size="30" /></p>'; 
    
    return $fields;    
}
endif;
add_filter( 'comment_form_default_fields', 'travel_planning_change_comment_form_default_fields' );

if( ! function_exists( 'travel_planning_change_comment_form_defaults' ) ) :
/**
 * Change Comment Form defaults
 * https://blog.josemcastaneda.com/2016/08/08/copy-paste-hurting-theme/
*/
function travel_planning_change_comment_form_defaults( $defaults ){    
    $defaults['comment_field'] = '<p class="comment-form-comment"><label class="screen-reader-text" for="comment">' . esc_html__( 'Comment', 'travel-planning' ) . '</label><textarea id="comment" name="comment" placeholder="' . esc_attr__( 'Comment', 'travel-planning' ) . '" cols="45" rows="8" aria-required="true" required></textarea></p>';
    
    return $defaults;    
}
endif;
add_filter( 'comment_form_defaults', 'travel_planning_change_comment_form_defaults' );

if( ! function_exists( 'travel_planning_escape_text_tags' ) ) :
/**
 * Remove new line tags from string
 *
 * @param $text
 * @return string
 */
function travel_planning_escape_text_tags( $text ) {
    return (string) str_replace( array( "\r", "\n" ), '', strip_tags( $text ) );
}
endif;

if( ! function_exists( 'wp_body_open' ) ) :
/**
 * Fire the wp_body_open action.
 * Added for backwards compatibility to support pre 5.2.0 WordPress versions.
*/
function wp_body_open() {
    /**
     * Triggered after the opening <body> tag.
    */
    do_action( 'wp_body_open' );
}
endif;

if ( ! function_exists( 'travel_planning_get_fallback_svg' ) ) :    
/**
 * Get Fallback SVG
*/
function travel_planning_get_fallback_svg( $travel_planning_post_thumbnail ) {
    if( ! $travel_planning_post_thumbnail ){
        return;
    }
    
    $travel_planning_image_size = travel_planning_get_image_sizes( $travel_planning_post_thumbnail );
     
    if( $travel_planning_image_size ){ ?>
        <div class="svg-holder">
             <svg class="fallback-svg" viewBox="0 0 <?php echo esc_attr( $travel_planning_image_size['width'] ); ?> <?php echo esc_attr( $travel_planning_image_size['height'] ); ?>" preserveAspectRatio="none">
                    <rect width="<?php echo esc_attr( $travel_planning_image_size['width'] ); ?>" height="<?php echo esc_attr( $travel_planning_image_size['height'] ); ?>" style="fill:#dedddd;"></rect>
            </svg>
        </div>
        <?php
    }
}
endif;

function travel_planning_enqueue_google_fonts() {

    require get_template_directory() . '/inc/wptt-webfont-loader.php';

    wp_enqueue_style(
        'google-fonts-outfit',
        travel_planning_wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Outfit:wght@100..900&display=swap' ),
        array(),
        '1.0'
    );

    wp_enqueue_style(
        'google-fonts-roboto',
        travel_planning_wptt_get_webfont_url( 'https://fonts.googleapis.com/css2?family=Roboto:ital,wght@0,100..900;1,100..900&display=swap' ),
        array(),
        '1.0'
    );
}
add_action( 'wp_enqueue_scripts', 'travel_planning_enqueue_google_fonts' );


if( ! function_exists( 'travel_planning_site_branding' ) ) :
/**
 * Site Branding
*/
function travel_planning_site_branding(){
    $travel_planning_logo_site_title = get_theme_mod( 'header_site_title', 1 );
    $travel_planning_tagline = get_theme_mod( 'header_tagline', false );
    $travel_planning_logo_width = get_theme_mod('logo_width', 100); // Retrieve the logo width setting

    ?>
    <div class="site-branding" style="max-width: <?php echo esc_attr(get_theme_mod('logo_width', '-1'))?>px;">
        <?php 
        // Check if custom logo is set and display it
        if (function_exists('has_custom_logo') && has_custom_logo()) {
            the_custom_logo();
        }
        if ($travel_planning_logo_site_title):
             if (is_front_page()): ?>
            <h1 class="site-title" style="font-size: <?php echo esc_attr(get_theme_mod('travel_planning_site_title_size', '20')); ?>px;">
            <a href="<?php echo esc_url(home_url('/')); ?>" rel="home"><?php bloginfo('name'); ?></a>
          </h1>
            <?php else: ?>
                <p class="site-title" itemprop="name">
                    <a href="<?php echo esc_url(home_url('/')); ?>" rel="home"><?php bloginfo('name'); ?></a>
                </p>
            <?php endif; ?>
        <?php endif; 
    
        if ($travel_planning_tagline) :
            $travel_planning_description = get_bloginfo('description', 'display');
            if ($travel_planning_description || is_customize_preview()) :
        ?>
                <p class="site-description" itemprop="description"><?php echo $travel_planning_description; ?></p>
            <?php endif;
        endif;
        ?>
    </div>
    <?php
}
endif;
if( ! function_exists( 'travel_planning_navigation' ) ) :
    /**
     * Site Navigation
    */
    function travel_planning_navigation(){
        ?>
        <nav class="main-navigation" id="site-navigation" role="navigation">
            <?php 
            wp_nav_menu( array( 
                'theme_location' => 'primary', 
                'menu_id' => 'primary-menu' 
            ) ); 
            ?>
        </nav>
        <?php
    }
endif;

if( ! function_exists( 'travel_planning_header' ) ) :
    /**
     * Header Start
    */
    function travel_planning_header(){

        $travel_planning_topbar         = get_theme_mod( 'travel_planning_topbar_setting', false );
        $travel_planning_header_image   = get_header_image();
        $travel_planning_sticky_header  = get_theme_mod( 'travel_planning_sticky_header' );
        $travel_planning_header_setting = get_theme_mod( 'travel_planning_header_setting', false );      

        $travel_planning_email          = get_theme_mod( 'travel_planning_header_email' );
        $travel_planning_header_phone   = get_theme_mod( 'travel_planning_header_phone' );
        $travel_planning_location       = get_theme_mod( 'travel_planning_header_location' );

        $travel_planning_header_btn_url    = get_theme_mod( 'travel_planning_header_btn_url' );
        $travel_planning_header_button_text = get_theme_mod( 'travel_planning_header_button_text' );

        $travel_planning_social_icon    = get_theme_mod( 'travel_planning_social_icon_setting', false );

        // Icons 
        $travel_planning_mail_icon   = get_theme_mod( 'travel_planning_mail_icon', 'fas fa-envelope-open-text' ) ?: 'fas fa-envelope-open-text';
        $travel_planning_phone_icon  = get_theme_mod( 'travel_planning_phone_icon', 'fas fa-phone' ) ?: 'fas fa-phone';
        $travel_planning_marker_icon = get_theme_mod( 'travel_planning_marker_icon', 'fas fa-map-marker-alt' ) ?: 'fas fa-map-marker-alt';
        ?>
        <div id="page-site-header" class="main-header">
            <header id="masthead" class="site-header header-inner" role="banner">
                <div class="theme-menu head_bg"
                    <?php if ( ! empty( $travel_planning_header_image ) ) : ?>
                        style="background-image:url('<?php echo esc_url( $travel_planning_header_image ); ?>');background-repeat:no-repeat;background-size:cover;"
                    <?php endif; ?>
                    data-sticky="<?php echo esc_attr( $travel_planning_sticky_header ?: '' ); ?>">

                    <?php if ( $travel_planning_topbar ) : ?>
                        <div class="topbar">
                            <div class="white-space"></div>
                            <div class="topbar-info">
                                <div class="header-email">
                                    <?php if ( $travel_planning_email ) : ?>
                                        <span>
                                            <a href="mailto:<?php echo esc_attr( $travel_planning_email ); ?>">
                                                <i class="<?php echo esc_attr( $travel_planning_mail_icon ); ?>"></i>
                                                <?php echo esc_html( $travel_planning_email ); ?>
                                            </a>
                                        </span>
                                    <?php endif; ?>
                                </div>

                                <div>
                                    <?php if ( $travel_planning_header_phone ) : ?>
                                        <span>
                                            <a href="tel:<?php echo esc_attr( $travel_planning_header_phone ); ?>">
                                                <i class="<?php echo esc_attr( $travel_planning_phone_icon ); ?>"></i>
                                                <?php echo esc_html( $travel_planning_header_phone ); ?>
                                            </a>
                                        </span>
                                    <?php endif; ?>
                                </div>

                                <div>
                                    <?php if ( $travel_planning_location ) : ?>
                                        <span>
                                            <a href="https://www.google.com/maps/search/<?php echo urlencode( $travel_planning_location ); ?>" target="_blank" rel="noopener">
                                                <i class="<?php echo esc_attr( $travel_planning_marker_icon ); ?>"></i>
                                                <?php echo esc_html( $travel_planning_location ); ?>
                                            </a>
                                        </span>
                                    <?php endif; ?>
                                </div>

                                <div>
                                    <?php if ( $travel_planning_social_icon ) : ?>
                                        <div class="social-links">
                                            <?php
                                            $travel_planning_social_link1 = get_theme_mod( 'travel_planning_social_link_1');
                                            $travel_planning_social_link2 = get_theme_mod( 'travel_planning_social_link_2');
                                            $travel_planning_social_link3 = get_theme_mod( 'travel_planning_social_link_3');
                                            $travel_planning_social_link4 = get_theme_mod( 'travel_planning_social_link_4');

                                            if ( $travel_planning_social_link1 ) {
                                                echo '<a class="social1" href="' . esc_url( $travel_planning_social_link1 ) . '" target="_blank"><i class="fab fa-facebook-f"></i></a>';
                                            }
                                            if ( $travel_planning_social_link4 ) {
                                                echo '<a class="social4" href="' . esc_url( $travel_planning_social_link4 ) . '" target="_blank"><i class="fab fa-instagram"></i></a>';
                                            }
                                            if ( $travel_planning_social_link2 ) {
                                                echo '<a class="social2" href="' . esc_url( $travel_planning_social_link2 ) . '" target="_blank"><i class="fa-brands fa-twitter"></i></a>';
                                            }
                                            if ( $travel_planning_social_link3 ) {
                                                echo '<a class="social3" href="' . esc_url( $travel_planning_social_link3 ) . '" target="_blank"><i class="fab fa-youtube"></i></a>';
                                            }
                                            ?>
                                        </div>
                                    <?php endif; ?>
                                </div>
                            </div>
                        </div>
                    <?php endif; ?>

                    <div class="container">
                        <div class="row menu-bg">
                            <div class="col-xl-2 col-lg-2 col-md-6 col-12 align-self-center">
                                <?php travel_planning_site_branding(); ?>
                            </div>
                            <div class="col-xl-10 col-lg-10 col-md-6 col-12 align-self-center">
                                <div class="menu-navigation">
                                    <?php travel_planning_navigation(); ?>

                                    <div class="header-btn">
                                        <?php if ( $travel_planning_header_button_text && $travel_planning_header_btn_url ) : ?>
                                            <a href="<?php echo esc_url( $travel_planning_header_btn_url ); ?>">
                                                <?php echo esc_html( $travel_planning_header_button_text ); ?>
                                                <i class="fas fa-chevron-right"></i>
                                            </a>
                                        <?php endif; ?>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                </div>
            </header>
        </div>
        <?php
    }
endif;

add_action( 'travel_planning_header', 'travel_planning_header', 20 );